#include "simulator.h"
#include "event.h"
#include "seeds.h"

extern int adjMatrix[numNodes][numNodes];

extern bool isTx[numNodes];
extern int  recv[numNodes];
extern bool isRx[numNodes];
extern int  trns[numNodes];

bool     Simulator::active = true;
ofstream Simulator::foo;

Simulator::Simulator()
	{
	node::setStatic(&eventList, &log, this);

    for(int i=0; i<numNodes; i++)
    	nodes[i].scheduleFirst();
	}

void Simulator::run()
	{
    long timeSlot = 0;

    Seeds::init();

	while(1)
		{
		Event ev = eventList.getEvent();

        while(ev.getTime() - timeSlot >= MINISLOTTIME)
        	{
            Seeds::regenerate_seeds();
            for(int i=0; i<numNodes; i++)
            	nodes[i].tick();
                
            timeSlot += MINISLOTTIME;
            }

		if(ev.getType() == null || ev.getTime() > eTime)
			break;

		processEvent(ev);
		}

	log.show();
//  log.consecutive();
    log.order();
	}

void Simulator::processEvent(Event e)
	{
#ifdef DEBUG
    static long count = 0;
//    count++;
    if(count == 10000)
    	active = false;

    if(active)
    	{
		char str[200];
		e.display(str);
		foo << "-------------------------------------------------------------------------" << endl;
		foo << "NOTIFY: " << str;
        }
#endif

	nodes[e.getTx()].notify(e);
	}

void Simulator::broadcastEvent(int id, Event e)
	{
#ifdef DEBUG
if(active)
	{
	foo << "BROADCAST!" << endl;
    }
#endif

	for(int i = 0; i<numNodes; i++)
		if(adjMatrix[id][i])				// A transmission from i must also be sent to i
        	{
			nodes[i].receive(e);		//   so that idleSince is decremented properly!
            }
	}

void Simulator::broadcastBTr(int id, bool on)
	{
	for(int i = 0; i<numNodes; i++)
		if(adjMatrix[id][i])
        	{
			nodes[i].rBusyTone(on);
            }
    }

void Simulator::NRA_ALL(int n)
	{
    for(int i=0 ; i<numNodes; i++)
    	nodes[i].setNRA_ALL(n);
    }










